/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.datatypes.CBitField;
import com.ibm.etools.c.datatypes.CBoolean;
import com.ibm.etools.c.datatypes.CChar;
import com.ibm.etools.c.datatypes.CDirectionKind;
import com.ibm.etools.c.datatypes.CDouble;
import com.ibm.etools.c.datatypes.CEnumeration;
import com.ibm.etools.c.datatypes.CFloat;
import com.ibm.etools.c.datatypes.CFloating;
import com.ibm.etools.c.datatypes.CInt;
import com.ibm.etools.c.datatypes.CIntegral;
import com.ibm.etools.c.datatypes.CLong;
import com.ibm.etools.c.datatypes.CLongDouble;
import com.ibm.etools.c.datatypes.CLongLong;
import com.ibm.etools.c.datatypes.CShort;
import com.ibm.etools.c.datatypes.CSignedChar;
import com.ibm.etools.c.datatypes.CUnsignedChar;
import com.ibm.etools.c.datatypes.CUnsignedInt;
import com.ibm.etools.c.datatypes.CUnsignedLong;
import com.ibm.etools.c.datatypes.CUnsignedLongLong;
import com.ibm.etools.c.datatypes.CUnsignedShort;
import com.ibm.etools.c.datatypes.CVoid;
import com.ibm.etools.c.datatypes.CWchar;
import com.ibm.etools.c.datatypes.DatatypesFactory;
import com.ibm.etools.c.datatypes.DatatypesPackage;
import com.ibm.etools.c.impl.CPackageImpl;
import com.ibm.etools.c.source.SourcePackage;
import com.ibm.etools.c.source.impl.SourcePackageImpl;
import com.ibm.etools.tdlang.TDLangPackage;
import com.ibm.etools.tdlang.impl.TDLangPackageImpl;
import com.ibm.etools.typedescriptor.TypeDescriptorPackage;
import com.ibm.etools.typedescriptor.impl.TypeDescriptorPackageImpl;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package </b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class DatatypesPackageImpl extends EPackageImpl implements DatatypesPackage {
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cLongDoubleEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cFloatingEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cFloatEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cUnsignedShortEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cDoubleEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cShortEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cUnsignedLongLongEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cLongLongEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cUnsignedLongEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cIntegralEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cLongEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cUnsignedCharEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cCharEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cVoidEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cWcharEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cIntEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cUnsignedIntEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cBitFieldEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cSignedCharEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass cEnumerationEClass = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EEnum cBooleanEEnum = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EEnum cDirectionKindEEnum = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EDataType cStringEDataType = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private EDataType cIntegerEDataType = null;

    /**
     * Creates an instance of the model <b>Package </b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry}by the
     * package package URI value.
     * <p>
     * Note: the correct way to create the package is via the static factory
     * method {@link #init init()}, which also performs initialization of the
     * package, or returns the registered package, if one already exists. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see com.ibm.etools.c.datatypes.DatatypesPackage#eNS_URI
     * @see #init()
     * @generated
     */
    private DatatypesPackageImpl() {
        super(eNS_URI, DatatypesFactory.eINSTANCE);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private static boolean isInited = false;

    /**
     * Creates, registers, and initializes the <b>Package </b> for this model,
     * and for any others upon which it depends. Simple dependencies are
     * satisfied by calling this method on all dependent packages before doing
     * anything else. This method drives initialization for interdependent
     * packages directly, in parallel with this package, itself.
     * <p>
     * Of this package and its interdependencies, all packages which have not
     * yet been registered by their URI values are first created and registered.
     * The packages are then initialized in two steps: meta-model objects for
     * all of the packages are created before any are initialized, since one
     * package's meta-model objects may refer to those of another.
     * <p>
     * Invocation of this method will not affect any packages that have already
     * been initialized. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #eNS_URI
     * @see #createPackageContents()
     * @see #initializePackageContents()
     * @generated
     */
    public static DatatypesPackage init() {
        if (isInited)
            return (DatatypesPackage) EPackage.Registry.INSTANCE.get(DatatypesPackage.eNS_URI);

        // Obtain or create and register package.
        DatatypesPackageImpl theDatatypesPackage = (DatatypesPackageImpl) (EPackage.Registry.INSTANCE.get(eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(eNS_URI)
                : new DatatypesPackageImpl());

        isInited = true;

        // Obtain or create and register interdependencies
        CPackageImpl theCPackage = (CPackageImpl) (EPackage.Registry.INSTANCE.get(CPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(CPackage.eNS_URI) : CPackageImpl.eINSTANCE);
        SourcePackageImpl theSourcePackage = (SourcePackageImpl) (EPackage.Registry.INSTANCE.get(SourcePackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(SourcePackage.eNS_URI)
                : SourcePackageImpl.eINSTANCE);
        TDLangPackageImpl theTdlangPackage = (TDLangPackageImpl) (EPackage.Registry.INSTANCE.get(TDLangPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(TDLangPackage.eNS_URI)
                : TDLangPackageImpl.eINSTANCE);
        TypeDescriptorPackageImpl theTypedescriptorPackage = (TypeDescriptorPackageImpl) (EPackage.Registry.INSTANCE.get(TypeDescriptorPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE
                .get(TypeDescriptorPackage.eNS_URI)
                : TypeDescriptorPackageImpl.eINSTANCE);

        // Step 1: create meta-model objects
        theDatatypesPackage.createPackageContents();
        theCPackage.createPackageContents();
        theSourcePackage.createPackageContents();
        theTdlangPackage.createPackageContents();
        theTypedescriptorPackage.createPackageContents();

        // Step 2: complete initialization
        theDatatypesPackage.initializePackageContents();
        theCPackage.initializePackageContents();
        theSourcePackage.initializePackageContents();
        theTdlangPackage.initializePackageContents();
        theTypedescriptorPackage.initializePackageContents();

        return theDatatypesPackage;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCLongDouble() {
        return cLongDoubleEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCFloating() {
        return cFloatingEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCFloat() {
        return cFloatEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCUnsignedShort() {
        return cUnsignedShortEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCDouble() {
        return cDoubleEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCShort() {
        return cShortEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCUnsignedLongLong() {
        return cUnsignedLongLongEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCLongLong() {
        return cLongLongEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCUnsignedLong() {
        return cUnsignedLongEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCIntegral() {
        return cIntegralEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCLong() {
        return cLongEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCUnsignedChar() {
        return cUnsignedCharEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCChar() {
        return cCharEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCVoid() {
        return cVoidEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCWchar() {
        return cWcharEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCInt() {
        return cIntEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCUnsignedInt() {
        return cUnsignedIntEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCBitField() {
        return cBitFieldEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getCBitField_Size() {
        return (EAttribute) cBitFieldEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCBitField_BaseType() {
        return (EReference) cBitFieldEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCSignedChar() {
        return cSignedCharEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getCEnumeration() {
        return cEnumerationEClass;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getCEnumeration_Enumerator() {
        return (EReference) cEnumerationEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EEnum getCBoolean() {
        return cBooleanEEnum;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EEnum getCDirectionKind() {
        return cDirectionKindEEnum;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EDataType getCString() {
        return cStringEDataType;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EDataType getCInteger() {
        return cIntegerEDataType;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public DatatypesFactory getDatatypesFactory() {
        return (DatatypesFactory) getEFactoryInstance();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private boolean isCreated = false;

    /**
     * Creates the meta-model objects for the package. This method is guarded to
     * have no affect on any invocation but its first. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void createPackageContents() {
        if (isCreated)
            return;
        isCreated = true;

        // Create classes and their features
        cLongDoubleEClass = createEClass(CLONG_DOUBLE);

        cFloatingEClass = createEClass(CFLOATING);

        cFloatEClass = createEClass(CFLOAT);

        cUnsignedShortEClass = createEClass(CUNSIGNED_SHORT);

        cDoubleEClass = createEClass(CDOUBLE);

        cShortEClass = createEClass(CSHORT);

        cUnsignedLongLongEClass = createEClass(CUNSIGNED_LONG_LONG);

        cLongLongEClass = createEClass(CLONG_LONG);

        cUnsignedLongEClass = createEClass(CUNSIGNED_LONG);

        cIntegralEClass = createEClass(CINTEGRAL);

        cLongEClass = createEClass(CLONG);

        cUnsignedCharEClass = createEClass(CUNSIGNED_CHAR);

        cCharEClass = createEClass(CCHAR);

        cVoidEClass = createEClass(CVOID);

        cWcharEClass = createEClass(CWCHAR);

        cIntEClass = createEClass(CINT);

        cUnsignedIntEClass = createEClass(CUNSIGNED_INT);

        cBitFieldEClass = createEClass(CBIT_FIELD);
        createEAttribute(cBitFieldEClass, CBIT_FIELD__SIZE);
        createEReference(cBitFieldEClass, CBIT_FIELD__BASE_TYPE);

        cSignedCharEClass = createEClass(CSIGNED_CHAR);

        cEnumerationEClass = createEClass(CENUMERATION);
        createEReference(cEnumerationEClass, CENUMERATION__ENUMERATOR);

        // Create enums
        cBooleanEEnum = createEEnum(CBOOLEAN);
        cDirectionKindEEnum = createEEnum(CDIRECTION_KIND);

        // Create data types
        cStringEDataType = createEDataType(CSTRING);
        cIntegerEDataType = createEDataType(CINTEGER);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private boolean isInitialized = false;

    /**
     * Complete the initialization of the package and its meta-model. This
     * method is guarded to have no affect on any invocation but its first. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void initializePackageContents() {
        if (isInitialized)
            return;
        isInitialized = true;

        // Initialize package
        setName(eNAME);
        setNsPrefix(eNS_PREFIX);
        setNsURI(eNS_URI);

        // Obtain other dependent packages
        CPackageImpl theCPackage = (CPackageImpl) EPackage.Registry.INSTANCE.getEPackage(CPackage.eNS_URI);

        // Add supertypes to classes
        cLongDoubleEClass.getESuperTypes().add(this.getCFloating());
        cFloatingEClass.getESuperTypes().add(theCPackage.getCDatatype());
        cFloatEClass.getESuperTypes().add(this.getCFloating());
        cUnsignedShortEClass.getESuperTypes().add(this.getCUnsignedInt());
        cDoubleEClass.getESuperTypes().add(this.getCFloating());
        cShortEClass.getESuperTypes().add(this.getCInt());
        cUnsignedLongLongEClass.getESuperTypes().add(this.getCUnsignedInt());
        cLongLongEClass.getESuperTypes().add(this.getCInt());
        cUnsignedLongEClass.getESuperTypes().add(this.getCUnsignedInt());
        cIntegralEClass.getESuperTypes().add(theCPackage.getCDatatype());
        cLongEClass.getESuperTypes().add(this.getCInt());
        cUnsignedCharEClass.getESuperTypes().add(this.getCChar());
        cCharEClass.getESuperTypes().add(this.getCIntegral());
        cVoidEClass.getESuperTypes().add(theCPackage.getCDatatype());
        cWcharEClass.getESuperTypes().add(this.getCChar());
        cIntEClass.getESuperTypes().add(this.getCIntegral());
        cUnsignedIntEClass.getESuperTypes().add(this.getCInt());
        cBitFieldEClass.getESuperTypes().add(theCPackage.getCDatatype());
        cSignedCharEClass.getESuperTypes().add(this.getCChar());
        cEnumerationEClass.getESuperTypes().add(this.getCIntegral());

        // Initialize classes and features; add operations and parameters
        initEClass(cLongDoubleEClass, CLongDouble.class, "CLongDouble", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cFloatingEClass, CFloating.class, "CFloating", IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cFloatEClass, CFloat.class, "CFloat", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cUnsignedShortEClass, CUnsignedShort.class, "CUnsignedShort", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cDoubleEClass, CDouble.class, "CDouble", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cShortEClass, CShort.class, "CShort", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cUnsignedLongLongEClass, CUnsignedLongLong.class, "CUnsignedLongLong", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cLongLongEClass, CLongLong.class, "CLongLong", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cUnsignedLongEClass, CUnsignedLong.class, "CUnsignedLong", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cIntegralEClass, CIntegral.class, "CIntegral", IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cLongEClass, CLong.class, "CLong", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cUnsignedCharEClass, CUnsignedChar.class, "CUnsignedChar", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cCharEClass, CChar.class, "CChar", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cVoidEClass, CVoid.class, "CVoid", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cWcharEClass, CWchar.class, "CWchar", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cIntEClass, CInt.class, "CInt", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cUnsignedIntEClass, CUnsignedInt.class, "CUnsignedInt", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cBitFieldEClass, CBitField.class, "CBitField", !IS_ABSTRACT, !IS_INTERFACE);
        initEAttribute(getCBitField_Size(), ecorePackage.getEIntegerObject(), "size", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED);
        initEReference(getCBitField_BaseType(), this.getCIntegral(), null, "baseType", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
                IS_UNIQUE, !IS_DERIVED);

        initEClass(cSignedCharEClass, CSignedChar.class, "CSignedChar", !IS_ABSTRACT, !IS_INTERFACE);

        initEClass(cEnumerationEClass, CEnumeration.class, "CEnumeration", !IS_ABSTRACT, !IS_INTERFACE);
        initEReference(getCEnumeration_Enumerator(), theCPackage.getCEnumerator(), theCPackage.getCEnumerator_Enumeration(), "enumerator", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
                IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED);

        // Initialize enums and add enum literals
        initEEnum(cBooleanEEnum, CBoolean.class, "CBoolean");
        addEEnumLiteral(cBooleanEEnum, CBoolean.TRUE_LITERAL);
        addEEnumLiteral(cBooleanEEnum, CBoolean.FALSE_LITERAL);

        initEEnum(cDirectionKindEEnum, CDirectionKind.class, "CDirectionKind");
        addEEnumLiteral(cDirectionKindEEnum, CDirectionKind.PARAMETER_LITERAL);
        addEEnumLiteral(cDirectionKindEEnum, CDirectionKind.RETURN_LITERAL);

        // Initialize data types
        initEDataType(cStringEDataType, String.class, "CString", IS_SERIALIZABLE);
        initEDataType(cIntegerEDataType, String.class, "CInteger", IS_SERIALIZABLE);
    }
} //DatatypesPackageImpl
