/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLFactoryImpl.java,v 1.2.4.1 2005/10/28 04:37:27 akkina Exp $
 */
package com.ibm.etools.cobol.impl;

import com.ibm.etools.cobol.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class COBOLFactoryImpl extends EFactoryImpl implements COBOLFactory {
	/**
	 * Creates and instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case COBOLPackage.COBOL_ELEMENT: return createCOBOLElement();
			case COBOLPackage.COBOL_VARIABLE_LENGTH_ARRAY: return createCOBOLVariableLengthArray();
			case COBOLPackage.COBOL_REDEFINING_ELEMENT: return createCOBOLRedefiningElement();
			case COBOLPackage.COBOL_COMPOSED_TYPE: return createCOBOLComposedType();
			case COBOLPackage.COBOL_88_ELEMENT: return createCOBOL88Element();
			case COBOLPackage.COBOL_88_ELEMENT_VALUE: return createCOBOL88ElementValue();
			case COBOLPackage.COBOL_ALPHA_NUMERIC_TYPE: return createCOBOLAlphaNumericType();
			case COBOLPackage.COBOL_NUMERIC_EDITED_TYPE: return createCOBOLNumericEditedType();
			case COBOLPackage.COBOL_NUMERIC_TYPE: return createCOBOLNumericType();
			case COBOLPackage.COBOL_66_ELEMENT: return createCOBOL66Element();
			case COBOLPackage.COBOL_FIXED_LENGTH_ARRAY: return createCOBOLFixedLengthArray();
			case COBOLPackage.COBOL_DBCS_TYPE: return createCOBOLDBCSType();
			case COBOLPackage.COBOL_ALPHA_NUMERIC_EDITED_TYPE: return createCOBOLAlphaNumericEditedType();
			case COBOLPackage.COBOL_ALPHABETIC_TYPE: return createCOBOLAlphabeticType();
			case COBOLPackage.COBOL_OBJECT_REFERENCE_TYPE: return createCOBOLObjectReferenceType();
			case COBOLPackage.COBOL_SOURCE_TEXT: return createCOBOLSourceText();
			case COBOLPackage.COBOL_UNICODE_TYPE: return createCOBOLUnicodeType();
			case COBOLPackage.COBOL_INTERNAL_FLOAT_TYPE: return createCOBOLInternalFloatType();
			case COBOLPackage.COBOL_EXTERNAL_FLOAT_TYPE: return createCOBOLExternalFloatType();
			case COBOLPackage.COBOL_ADDRESSING_TYPE: return createCOBOLAddressingType();
			case COBOLPackage.COBOL_ELEMENT_INITIAL_VALUE: return createCOBOLElementInitialValue();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case COBOLPackage.COBOL_USAGE_VALUES: {
				COBOLUsageValues result = COBOLUsageValues.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			case COBOLPackage.COBOL_INITIAL_VALUE_KIND: {
				COBOLInitialValueKind result = COBOLInitialValueKind.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			case COBOLPackage.COBOL_TRUNC_VALUE: {
				COBOLTruncValue result = COBOLTruncValue.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			case COBOLPackage.COBOL_NUMPROC_VALUE: {
				COBOLNumprocValue result = COBOLNumprocValue.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case COBOLPackage.COBOL_USAGE_VALUES:
				return instanceValue == null ? null : instanceValue.toString();
			case COBOLPackage.COBOL_INITIAL_VALUE_KIND:
				return instanceValue == null ? null : instanceValue.toString();
			case COBOLPackage.COBOL_TRUNC_VALUE:
				return instanceValue == null ? null : instanceValue.toString();
			case COBOLPackage.COBOL_NUMPROC_VALUE:
				return instanceValue == null ? null : instanceValue.toString();
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLElement createCOBOLElement() {
		COBOLElementImpl cobolElement = new COBOLElementImpl();
		return cobolElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLVariableLengthArray createCOBOLVariableLengthArray() {
		COBOLVariableLengthArrayImpl cobolVariableLengthArray = new COBOLVariableLengthArrayImpl();
		return cobolVariableLengthArray;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLRedefiningElement createCOBOLRedefiningElement() {
		COBOLRedefiningElementImpl cobolRedefiningElement = new COBOLRedefiningElementImpl();
		return cobolRedefiningElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLComposedType createCOBOLComposedType() {
		COBOLComposedTypeImpl cobolComposedType = new COBOLComposedTypeImpl();
		return cobolComposedType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOL88Element createCOBOL88Element() {
		COBOL88ElementImpl coboL88Element = new COBOL88ElementImpl();
		return coboL88Element;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOL88ElementValue createCOBOL88ElementValue() {
		COBOL88ElementValueImpl coboL88ElementValue = new COBOL88ElementValueImpl();
		return coboL88ElementValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLAlphaNumericType createCOBOLAlphaNumericType() {
		COBOLAlphaNumericTypeImpl cobolAlphaNumericType = new COBOLAlphaNumericTypeImpl();
		return cobolAlphaNumericType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLNumericEditedType createCOBOLNumericEditedType() {
		COBOLNumericEditedTypeImpl cobolNumericEditedType = new COBOLNumericEditedTypeImpl();
		return cobolNumericEditedType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLNumericType createCOBOLNumericType() {
		COBOLNumericTypeImpl cobolNumericType = new COBOLNumericTypeImpl();
		return cobolNumericType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOL66Element createCOBOL66Element() {
		COBOL66ElementImpl coboL66Element = new COBOL66ElementImpl();
		return coboL66Element;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLFixedLengthArray createCOBOLFixedLengthArray() {
		COBOLFixedLengthArrayImpl cobolFixedLengthArray = new COBOLFixedLengthArrayImpl();
		return cobolFixedLengthArray;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLDBCSType createCOBOLDBCSType() {
		COBOLDBCSTypeImpl coboldbcsType = new COBOLDBCSTypeImpl();
		return coboldbcsType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLAlphaNumericEditedType createCOBOLAlphaNumericEditedType() {
		COBOLAlphaNumericEditedTypeImpl cobolAlphaNumericEditedType = new COBOLAlphaNumericEditedTypeImpl();
		return cobolAlphaNumericEditedType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLAlphabeticType createCOBOLAlphabeticType() {
		COBOLAlphabeticTypeImpl cobolAlphabeticType = new COBOLAlphabeticTypeImpl();
		return cobolAlphabeticType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLObjectReferenceType createCOBOLObjectReferenceType() {
		COBOLObjectReferenceTypeImpl cobolObjectReferenceType = new COBOLObjectReferenceTypeImpl();
		return cobolObjectReferenceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLSourceText createCOBOLSourceText() {
		COBOLSourceTextImpl cobolSourceText = new COBOLSourceTextImpl();
		return cobolSourceText;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLUnicodeType createCOBOLUnicodeType() {
		COBOLUnicodeTypeImpl cobolUnicodeType = new COBOLUnicodeTypeImpl();
		return cobolUnicodeType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLInternalFloatType createCOBOLInternalFloatType() {
		COBOLInternalFloatTypeImpl cobolInternalFloatType = new COBOLInternalFloatTypeImpl();
		return cobolInternalFloatType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLExternalFloatType createCOBOLExternalFloatType() {
		COBOLExternalFloatTypeImpl cobolExternalFloatType = new COBOLExternalFloatTypeImpl();
		return cobolExternalFloatType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLAddressingType createCOBOLAddressingType() {
		COBOLAddressingTypeImpl cobolAddressingType = new COBOLAddressingTypeImpl();
		return cobolAddressingType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLElementInitialValue createCOBOLElementInitialValue() {
		COBOLElementInitialValueImpl cobolElementInitialValue = new COBOLElementInitialValueImpl();
		return cobolElementInitialValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public COBOLPackage getCOBOLPackage() {
		return (COBOLPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static COBOLPackage getPackage() {
		return COBOLPackage.eINSTANCE;
	}

} //COBOLFactoryImpl
